%polynomial model identification method
%[hm,hh,hl,ee]=polyid1(yd,ud,N,ted1,ted2)
%where yd, ud are the output-input data with same length. 
%yd and ud are column vectors
%N is the order of polynomial minus 1
%tmin and tmax are dead time and final time
%hm1 is the impulse response
%hh1 and hl1 are the 95% confidence interval of hm.
%ee1 is the prediction error

%Assumption: h(tmax)=0;h'(tmax)=0;

function [hm1,hh1,hl1,ee1]=polyid11(yd,ud,N,tmin,tmax)
%echo off
size(yd);
size(ud);
%tmin=a(1);
%tmax=a(2);
%get q,r,m
q=floor(tmin);
r=floor(tmax);
m=length(yd);

alpha=1;  %decide alpha and beta here
beta=1;

%decide the jacob polynomial order
A2=[];
[dif1,dif2,dif3,root]=ying1(N+2,N,1,1,alpha,beta);

A1=[];
for i=1:r-q
   xi=((i+q)*1-tmin)/(tmax-tmin);
   xintp=ying2(N+2,N+2,xi,root,dif1);
   A1=[A1;xintp'];
end
A1=[[1, zeros(1,N+1)];A1];

A2=[];
%convolve with inputs
for i=1:N+2;
   dum=conv([zeros(q-1,1);A1(:,i)],ud);
   dumsize=size(dum);
   if dumsize(1)~=1
      dum=dum';
   end
   
   A2(:,i)=dum(q:m)';
end


A=A2(:,1:N+1);

B=yd(q:m)';
%implement the end point constraints
vec1=[];
vec2=[];
ND=N+2;
N0=1;
N1=1;
   id=1;
   vec1=ying3(ND,N,N0,N1,1,id,dif1,dif2,dif3,root);
   vec2=ying3(ND,N,N0,N1,ND,id,dif1,dif2,dif3,root);
   vec1=vec1(1:ND-1);
   vec2=vec2(1:ND-1);
   
   vec1=vec1';
   vec2=vec2';
   
   soN=-vec2(1:N)/vec2(N+1);

   A4=A(:,1:N)+A(:,N+1)*soN;
   
   size(A4);
   size(B);
   
   %calculate the coefficients 
   h=(A4'*A4)^(-1)*A4'*B;

h=[h;soN*h];

%calculate the impulse reponse
ffftt1=[];
valuei1=[];
%plot(e);
%hold on;
cc=h';
for i=1:1:floor(tmax)+1
   x=(i-tmin-1)/(tmax-tmin);
   if x<0
      valuei=0;
   else
      xintp=ying2(N+2,N+2,x,root,dif1);
      ffftt1=[ffftt1,i-1];
      valuei1=[valuei1;[cc,0]*xintp];
   end
%   plot(i-1,valuei,'r') %plot the curve
end

%save ying6

hm=[zeros(ffftt1(1)-1,1);valuei1;zeros(-ffftt1(length(ffftt1))+length(yd),1)];

%predicted output
y=conv(hm,ud);
o=size(y);
if o(2)==1
   y=y';
end

o=size(yd);
if o(2)==1
   yd=yd';
end
%prediction error
ee=(yd-y(1:length(yd)))*(yd-y(1:length(yd)))';

ha=ee/(length(yd)-N+1)      ;


%confidence limit calculation
piii=(A4'*A4)^(-1);
vh=piii*ha;

vhi=[];
for i=1:length(A1);
   vhi(i)=(A1(i,1:N)+soN*A1(i,N+1))*vh*(A1(i,1:N)+soN*A1(i,N+1))';
end


delth=1.96*vhi.^.5;

%obtain the results
hm1=hm;
hh1=hm(1:floor(tmax))+[zeros(1,floor(tmin-1)),delth]';
hl1=hm(1:floor(tmax))-[zeros(1,floor(tmin-1)),delth]';
ee1=ee;
%plot(hm(1:tmax)+[zeros(1,tmin-1),delth]','r--')
%plot(hm(1:tmax)-[zeros(1,tmin-1),delth]','r--')






%%save 10241